package adminbenefactorvalidator

import (
	"context"
	"errors"

	param "git.gocasts.ir/ebhomengo/niki/param/admin/benefactor"
	errmsg "git.gocasts.ir/ebhomengo/niki/pkg/err_msg"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
	validation "github.com/go-ozzo/ozzo-validation/v4"
)

func (v Validator) ValidateUpdateStatusRequest(ctx context.Context, req param.BenefactorUpdateStatusRequest) (map[string]string, error) {
	const op = "adminbenefactorvalidator.ValidateUpdateStatusRequest"

	if err := validation.ValidateStruct(&req,
		validation.Field(&req.ID,
			validation.Required,
			validation.By(v.doesBenefactorExist(ctx))),
		validation.Field(&req.Status,
			validation.By(v.doesBenefactorStatusExist)),
	); err != nil {
		fieldErrors := make(map[string]string)

		vErr := validation.Errors{}
		if errors.As(err, &vErr) {
			for key, value := range vErr {
				if value != nil {
					fieldErrors[key] = value.Error()
				}
			}
		}

		return fieldErrors, richerror.New(op).WithMessage(errmsg.ErrorMsgInvalidInput).
			WithKind(richerror.KindInvalid).
			WithMeta(map[string]interface{}{"req": req}).WithErr(err)
	}

	return nil, nil
}
